import java.sql.*;
import com.adventnet.nms.util.DBParamsParser;
import com.adventnet.nms.util.NmsUtil;
import java.io.File;

public class RemoveDBEntries
{
	private static final String dbParamsConf = "conf/database_params.conf";
	private static Connection conn = null;
    
    public static void main (String args[]) throws Exception
    {
        if (args.length != 1)
        {
            System.out.println("Specify the device name to be removed. [Usage: RemoveDBEntries <devicename>] ");
            return;
        }
        conn = getDBConnection(dbParamsConf); 
	if(conn == null)
	{
		System.out.println("Unable to create DB connection");
		return;
	}
        String devicename = args[0];
        Statement stmt = conn.createStatement();
        String[] queries = {
		"delete from NetworkRangeTable",
            "delete from Alert where Source like '%" + devicename + "%'",
            "delete from CHILDRENSTATUS where KEYSTRING like '%" + devicename + "%'",
            "delete from DBINTERFACES where VALUESTRING like '%" + devicename + "%'",
            "delete from DBMAP where KEYSTRING like '%" + devicename + "%'",
	        "delete from GroupTable where MEMBERNAME like '%" + devicename + "%'",
            "delete from InetService where NAME like '%" + devicename + "%'",
            "delete from IpAddress where NAME like '%" + devicename + "%'",
            "delete from ManagedObject where NAME like '%" + devicename + "%'",
            "delete from MapContainer where OBJNAME like '%" + devicename + "%'",
            "delete from MapSymbol where OBJNAME like '%" + devicename + "%'",
            "delete from Node where NAME like '%" + devicename + "%'",
            "delete from OpManagerObject where NAME like '%" + devicename + "%'",
            "delete from PolledData where AGENT like '%" + devicename + "%'",
			"delete from PortObject where NAME like '%" + devicename + "%'",
            "delete from SnmpInterface where NAME like '%" + devicename + "%'",
            "delete from SnmpNode where NAME like '%" + devicename + "%'",
			"delete from SwitchObject where NAME like '%" + devicename + "%'",
            "delete from TOPODBSPECIALKEY where KEYSTRING like '%" + devicename + "%'",
            "delete from TopoObject where NAME like '%" + devicename + "%'",
			"delete from CHILDRENSTATUS where KEYSTRING like '%" + devicename + "%'",
			"delete from CLIDetails where AGENTNAME like '%" + devicename + "%'",
			"delete from CustomFieldsForDevices where DEVICENAME like '%" + devicename + "%'",
			"delete from CustomFieldsForInterfaces where DEVICENAME like '%" + devicename + "%'",
			"delete from DCObject where NAME like '%" + devicename + "%'",
			"delete from DeviceToEventLogRuleMap where DEVICENAME like '%" + devicename + "%'",
			"delete from EventLogDeviceInfo where DEVICENAME like '%" + devicename + "%'",
			"delete from EventLogRunnable where DEVICENAME like '%" + devicename + "%'",
			"delete from HRDetails where AGENTNAME like '%" + devicename + "%'",
			"delete from InterfacesToNotify where NAME like '%" + devicename + "%'",
			"delete from MaintenanceDevices where MD_NAME like '%" + devicename + "%'",
			"delete from MapLink where SOURCE like '%" + devicename + "%'",
			"delete from MapLink where DEST like '%" + devicename + "%'",
			"delete from NamedInstanceObject where PARENTDEVICENAME like '%" + devicename + "%'",
			"delete from NTServices where DEVICENAME like '%" + devicename + "%'",
			"delete from OBJECTSTOLINK where KEYSTRING like '%" + devicename + "%'",
			"delete from OpmObjectDomainController where DEVICENAME like '%" + devicename + "%'",
			"delete from POLLUSERPROPS where AGENT like '%" + devicename + "%'",
			"delete from Printer where NAME like '%" + devicename + "%'",
			"delete from ProfileCriteria where CRITERIANAME like '%" + devicename + "%'",
			"delete from ScheduleDeviceNames where DEVICENAMES like '%" + devicename + "%'",
			"delete from Services where PARENTDEVICENAME like '%" + devicename + "%'",
			"delete from TOPOUSERPROPS where NAME like '%" + devicename + "%'",
			"delete from UPSObject where NAME like '%" + devicename + "%'"			
        };
        
        for (int i=0; i<queries.length; i++)
        {
            try
            {
                String query = queries [i];
                stmt.executeUpdate(query);
            }
            catch (Exception ex)
            {
                System.err.println("Exception removing entries: " + ex);
                ex.printStackTrace();
		return;
            }
        }
        System.out.println("The device is removed from the DB successfully.Please restart OpManager Server to make the changes effective.");
        System.exit(0);
        return;
    }


    public static Connection getDBConnection(String file) throws Exception
    {
	    try
	    {
		    DBParamsParser parser = DBParamsParser.getInstance(new File(file));
		    if(parser==null)
		    {
			    return null;
		    }
		    String url = parser.getURL();
		    String driverName = parser.getDriverName();
		    String userName = parser.getUserName();
		    String passWord = parser.getPassword();
		    Class.forName(driverName);
		    conn = DriverManager.getConnection(url,userName, passWord);
		    return conn;
	    }catch(Exception e)
	    {
		    e.printStackTrace();
	    }
	    return null;
    }
}    
